//+------------------------------------------------------------------+
//|                              YB_STF4TF_Chimp2_1_NR.mq4                                                             
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "YB_STF4TF_Chimp2_1_NR"
#include <Pop.mqh>

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Orange
#property indicator_color3 Red
#property indicator_width3 2
#property indicator_color4 Gold
#property indicator_width4 2
#property indicator_color5 Aqua//White  
#property indicator_width5 2

#property indicator_maximum 4                     
#property indicator_minimum -4

//=============================================================
#property indicator_level1 0
#property indicator_level2 1
#property indicator_level3 -1
#property indicator_level4 3.5
#property indicator_level5 -3.5
#property indicator_levelcolor BurlyWood  
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 0

//============================ INPUT ==========================
extern string     Input1             = "== Chimp A ===";
extern double  AWeightDM   = 2.5 ;
extern double  AWeightDI   = 2.0 ;
extern double  AWeightDX   = 1.0 ;
extern double  AWeightOut  = 2.0 ;

extern string     Input2             = "== Chimp B ===";
extern double  BWeightDM   = 2.5 ;
extern double  BWeightDI   = 2.0 ;
extern double  BWeightDX   = 1.0 ;
extern double  BWeightOut  = 1.0 ;

extern string     Input3             = "== Chimp C ===";
extern double  CWeightDM   = 2.5 ;
extern double  CWeightDI   = 2.0 ;
extern double  CWeightDX   = 1.0 ;
extern double  CWeightOut  = 1.0 ;

extern string     Input4             = "== Chimp D ===";
extern double  DWeightDM   = 1.5 ;
extern double  DWeightDI   = 1.0 ;
extern double  DWeightDX   = 1.0 ;
extern double  DWeightOut  = 1.0 ;
//===========================================================
extern int   MaPer         = 8 ;
extern int   MA_SiEmSmWe3  = 0 ;
extern int   MaShift       = 0 ;
extern int   LineSize1    = 2 ;
extern int   LineSize2    = 1 ;
extern int   LineSize3    = 2 ;
extern int   CountBars    = 600 ;
extern bool  NoName       = false ;

extern int    TFA  = 0 ;    
extern int    TFB  = 0 ;
extern int    TFC  = 0 ;
extern int    TFD  = 0 ;
//===========================================================
extern string     Filler             = "=== ALERTS ===";
extern bool    Use.Alert.On.Cross      = False;
extern bool    Use.Pop.MSN.Alerts      = False;
extern bool    Draw.Arrows.On.Chart    = True;
//-----------------------------------------------
extern string  Alert.On.Cross.Types0    = "   0 = Cross Anywhere                               ";
extern string  Alert.On.Cross.Types1    = "   1 = Cross Below threshold for Longs / Above threshold for Shorts ";
extern string  Alert.On.Cross.Types2    = "   2 = Cross Above threshold for Longs / Below threshold for Shorts ";
extern int     Alert.On.Cross.Type      = 0;
extern string  Alert.Threshold          = " ** Use only positive number below i.e 0.2 will be used for +0.2 and -0.2 **";
extern double  Alert.Threshold.Level    = 0.00;
//===========================================================




bool   StepTFA_Up   =  true; 
bool   StepTFB_Up   =  true; 
bool   StepTFC_Up   =  true; 
bool   StepTFD_Up   =  true; 

double MapBuffer1[];
double MapBuffer2[];
double MapBuffer3[];
double MapBuffer4[];
double MapBuffer5[];

datetime alertTag;
string signal;
string lastsignal;
int    iAlertCount=0;

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(+0);
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,LineSize1);
   SetIndexBuffer(0,MapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,LineSize2);
   SetIndexBuffer(1,MapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,LineSize1);
   SetIndexBuffer(2,MapBuffer3);
   
   SetIndexStyle(3,DRAW_LINE,EMPTY,LineSize3);
   SetIndexBuffer(3,MapBuffer4);
   
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,LineSize3);
   SetIndexBuffer(4,MapBuffer5);

//========================================================================================
     switch(TFA)   {    case 1 : string TimeFrameStrA="Period_M1"; break;
                        case 5 : TimeFrameStrA="Period_M5"; break;
                       case 15 : TimeFrameStrA="Period_M15"; break;
                       case 30 : TimeFrameStrA="Period_M30"; break;
                       case 60 : TimeFrameStrA="Period_H1"; break;
                      case 240 : TimeFrameStrA="Period_H4"; break;
                     case 1440 : TimeFrameStrA="Period_D1"; break;
                    case 10080 : TimeFrameStrA="Period_W1"; break;
                    case 43200 : TimeFrameStrA="Period_MN1"; break;
                       default : TimeFrameStrA="Current Timeframe";
                   SetStepTFA_Up();
                 }
//=======================================================================================      
    switch(TFB)   {     case 1 : string TimeFrameStrB="Period_M1"; break;
                        case 5 : TimeFrameStrB="Period_M5"; break;
                       case 15 : TimeFrameStrB="Period_M15"; break;
                       case 30 : TimeFrameStrB="Period_M30"; break;
                       case 60 : TimeFrameStrB="Period_H1"; break;
                      case 240 : TimeFrameStrB="Period_H4"; break;
                     case 1440 : TimeFrameStrB="Period_D1"; break;
                    case 10080 : TimeFrameStrB="Period_W1"; break;
                    case 43200 : TimeFrameStrB="Period_MN1"; break;
                       default : TimeFrameStrB="Current Timeframe";
                   SetStepTFB_Up();
                  }
//=======================================================================================     
    switch(TFC)    {    case 1 : string TimeFrameStrC="Period_M1"; break;
                        case 5 : TimeFrameStrC="Period_M5"; break;
                       case 15 : TimeFrameStrC="Period_M15"; break;
                       case 30 : TimeFrameStrC="Period_M30"; break;
                       case 60 : TimeFrameStrC="Period_H1"; break;
                      case 240 : TimeFrameStrC="Period_H4"; break;
                     case 1440 : TimeFrameStrC="Period_D1"; break;
                    case 10080 : TimeFrameStrC="Period_W1"; break;
                    case 43200 : TimeFrameStrC="Period_MN1"; break;
                       default : TimeFrameStrC="Current Timeframe";
                    SetStepTFC_Up();
                  }
//=======================================================================================     
    switch(TFD)    {    case 1 : string TimeFrameStrD="Period_M1"; break;
                        case 5 : TimeFrameStrD="Period_M5"; break;
                       case 15 : TimeFrameStrD="Period_M15"; break;
                       case 30 : TimeFrameStrD="Period_M30"; break;
                       case 60 : TimeFrameStrD="Period_H1"; break;
                      case 240 : TimeFrameStrD="Period_H4"; break;
                     case 1440 : TimeFrameStrD="Period_D1"; break;
                    case 10080 : TimeFrameStrD="Period_W1"; break;
                    case 43200 : TimeFrameStrD="Period_MN1"; break;
                       default : TimeFrameStrD="Current Timeframe";
                    SetStepTFD_Up();
                  }                  
//=======================================================================================  
 
      string short_name;
      IndicatorShortName("Chimp_4TF");// ?????????????
      SetIndexLabel(0,"Chimp_4TF");
//======================================================================================      
         }
          return(0);
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int deinit()
  {     Refresh();
        RemoveArrows();
        return(0);
  }          
//+--------------------------------------------------------------------------------------+
int start()
  {  Refresh();
     datetime TimeArray[]; datetime TimeArray1[]; datetime TimeArray2[];datetime TimeArray3[];
   
     int i,limit,counted_bars=IndicatorCounted();
     int y=0,y1=0,y2=0,y3=0;
     
    ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TFA); 
    ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),TFB); 
    ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),TFC); 
    ArrayCopySeries(TimeArray3,MODE_TIME,Symbol(),TFD); 
 
   limit=Bars-counted_bars;
//==============================================================================================       
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     SetIndexDrawBegin(4,Bars-CountBars); 
//========================  SHORTNAME  ==============================================================         
           if  ( NoName == false  )
         {    string  ThisName1 = "(Chimp_4TF)";//??????????????????
              string Text1=ThisName1;
              Text1=Text1+"(TF "+TFA;
              Text1=Text1+"/"+TFB;
              Text1=Text1+"/"+TFC;
              Text1=Text1+"/"+TFD;
              Text1=Text1+")";
              IndicatorShortName(Text1); 
               SetIndexLabel(0,"(Chimp_4TF)");//??????????????
         }  
//===============================================================================================          
    
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y])   y++;  
      if (Time[i]<TimeArray1[y1]) y1++;  
      if (Time[i]<TimeArray2[y2]) y2++;  
      if (Time[i]<TimeArray3[y3]) y3++;   
      
//=======================  HEADINGE  =============================================================   
 //   {    
 //  ObjectCreate ("HEAD_Chimp_4TF", OBJ_LABEL,WindowFind("Chimp_4TF"), 0, 0);//????????
 //  ObjectSetText("HEAD_Chimp_4TF", "Chimp_A" , 8, "Tahoma Narrow", Gold);
 //  ObjectSet    ("HEAD_Chimp_4TF", OBJPROP_CORNER, 1);
 //  ObjectSet    ("HEAD_Chimp_4TF", OBJPROP_XDISTANCE, 20);
 //  ObjectSet    ("HEAD_Chimp_4TF", OBJPROP_YDISTANCE, 5 ); 
 //  }

//===================== RSI A ========================================================================
      double totalUp = 0.0;
                            
      totalUp =           iCustom(NULL, TFA, "Chimp2_1", AWeightDM, AWeightDI, AWeightDX, AWeightOut, 0, y );
      totalUp = totalUp + iCustom(NULL, TFB, "Chimp2_1", BWeightDM, BWeightDI, BWeightDX, BWeightOut, 0, y1);
      totalUp = totalUp + iCustom(NULL, TFC, "Chimp2_1", CWeightDM, CWeightDI, CWeightDX, CWeightOut, 0, y2);
      totalUp = totalUp + iCustom(NULL, TFD, "Chimp2_1", DWeightDM, DWeightDI, DWeightDX, DWeightOut, 0, y3);
         
 //===============================================================================================  
  
      MapBuffer1[i] = 0;
      MapBuffer2[i] = 0;
      MapBuffer3[i] = 0;
      MapBuffer4[i] = 0;
      MapBuffer5[i] = 0;
 //========================================================================================         
        
      
      if ( totalUp > 0|| totalUp < 0 )
         MapBuffer1[i] = totalUp;
         MapBuffer4[i] = totalUp;
    
      
      if ( totalUp < 0 )
         MapBuffer3[i] = totalUp;  
       }   
         
   for(i=0,y=0;i<limit;i++)
   {  MapBuffer5[i] = iMAOnArray(MapBuffer4,0,MaPer,MaShift,MA_SiEmSmWe3,i);
   }  
   
   
   SetAlert(MapBuffer4[1],MapBuffer4[2],MapBuffer5[1],MapBuffer5[2]);
   DrawArrows();
   
      
   return(0);
}


 //================================================================================== ++       
             void SetValuesA(int pA)  {  TFA = pA;        }                                   
        void SetStepTFA_Up()     {  switch (Period() )                
           {  case PERIOD_M1  :  SetValuesA(PERIOD_M1);  break;       
              case PERIOD_M5  :  SetValuesA(PERIOD_M5);  break;         
              case PERIOD_M15 :  SetValuesA(PERIOD_M15); break;     
              case PERIOD_M30 :  SetValuesA(PERIOD_M30); break;            
              case PERIOD_H1  :  SetValuesA(PERIOD_H1);  break;               
              case PERIOD_H4  :  SetValuesA(PERIOD_H4);  break;                
              case PERIOD_D1  :  SetValuesA(PERIOD_D1);  break;                
              case PERIOD_W1  :  SetValuesA(PERIOD_W1);  break;             
              case PERIOD_MN1 :  SetValuesA(PERIOD_MN1); break;                   
           } }    

//==============================step timeframe up TF1====================================  
       void SetValuesB(int pB) { TFB = pB;        }                                    
       void SetStepTFB_Up()   { switch (Period() )                
           { case PERIOD_M1  :  SetValuesB(PERIOD_M5);    break;       
             case PERIOD_M5  :  SetValuesB(PERIOD_M15);   break;         
             case PERIOD_M15 :  SetValuesB(PERIOD_M30);   break;     
             case PERIOD_M30 :  SetValuesB(PERIOD_H1);    break;            
             case PERIOD_H1  :  SetValuesB(PERIOD_H4);    break;               
             case PERIOD_H4  :  SetValuesB(PERIOD_D1);    break;                
             case PERIOD_D1  :  SetValuesB(PERIOD_W1);    break;                
             case PERIOD_W1  :  SetValuesB(PERIOD_MN1);   break;             
             case PERIOD_MN1 :  SetValuesB(PERIOD_MN1);   break;                   
          } }   
//============================== TF2 ===================================================     
       void SetValuesC(int pC) {  TFC = pC;         }                                    
       void SetStepTFC_Up()    {  switch (Period()  )                
          { case PERIOD_M1  :  SetValuesC(PERIOD_M15);  break;       
            case PERIOD_M5  :  SetValuesC(PERIOD_M30);  break;         
            case PERIOD_M15 :  SetValuesC(PERIOD_H1);   break;     
            case PERIOD_M30 :  SetValuesC(PERIOD_H4);   break;            
            case PERIOD_H1  :  SetValuesC(PERIOD_D1);   break;               
            case PERIOD_H4  :  SetValuesC(PERIOD_W1);   break;                
            case PERIOD_D1  :  SetValuesC(PERIOD_MN1);  break;                
            case PERIOD_W1  :  SetValuesC(PERIOD_MN1);  break;             
            case PERIOD_MN1 :  SetValuesC(PERIOD_MN1);  break;                   
         } }    
//=============================== TF3 ==================================================  
        void SetValuesD(int pD)  {  TFD = pD;        }                                   
        void SetStepTFD_Up()     {  switch (Period() )                
           {  case PERIOD_M1  :  SetValuesD(PERIOD_M30); break;       
              case PERIOD_M5  :  SetValuesD(PERIOD_H1);  break;         
              case PERIOD_M15 :  SetValuesD(PERIOD_H4);  break;     
              case PERIOD_M30 :  SetValuesD(PERIOD_D1);  break;            
              case PERIOD_H1  :  SetValuesD(PERIOD_W1);  break;               
              case PERIOD_H4  :  SetValuesD(PERIOD_MN1); break;                
              case PERIOD_D1  :  SetValuesD(PERIOD_MN1); break;                
              case PERIOD_W1  :  SetValuesD(PERIOD_MN1); break;             
              case PERIOD_MN1 :  SetValuesD(PERIOD_MN1); break;              
           } }    
 //================================================================================== 
 //====================================================================
void Refresh() 
   {         ObjectDelete("HEAD_Chimp_4TF"); //???????????????    
      
   }


void SetAlert(double dChimp, double dChimp2, double dMA, double dMA2)
{
   if (Alert.On.Cross.Type==0)
   {  if ((dMA>dChimp) && (dMA2<dChimp2)) 
      {  if (Use.Alert.On.Cross)
         {  signal="Short";
            if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
            {  
               Alert ("MA Crossing Over Chimp ==> SHORT ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" MA Crossing Over Chimp ==> SHORT "), "C:\\");
               alertTag = Time[0];
               lastsignal=signal;
               iAlertCount++;
            }
         }
      }
      else 
      {  
         if ((dMA<dChimp) && (dMA2>dChimp2)) 
         {  
            if (Use.Alert.On.Cross)
            {  
               signal="Long";
               if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
               {  
                  Alert ("Chimp Crossing Over MA ==> LONG ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
                  if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" Chimp Crossing Over MA ==> LONG "), "C:\\");
                  alertTag = Time[0];
                  lastsignal=signal;
                  iAlertCount++;
               }
            }
         }
         else
         {  signal="None";
            iAlertCount=0;
         }
      }
   }
   
   else if (Alert.On.Cross.Type==1)
   {
      if ((dMA>dChimp) && (dMA2<dChimp2) && (dChimp>Alert.Threshold.Level)) 
      {  if (Use.Alert.On.Cross)
         {  signal="Short";
            if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
            {  
               Alert ("MA Crossing Over Chimp ==> SHORT ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" MA Crossing Over Chimp ==> SHORT "), "C:\\");
               alertTag = Time[0];
               lastsignal=signal;
               iAlertCount++;
            }
         }
      }
      else 
      {  
         if ((dMA<dChimp) && (dMA2>dChimp2) && (dChimp<Alert.Threshold.Level*(-1))) 
         {  
            if (Use.Alert.On.Cross)
            {  
               signal="Long";
               if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
               {  
                  Alert ("Chimp Crossing Over MA ==> LONG ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
                  if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" Chimp Crossing Over MA ==> LONG "), "C:\\");
                  alertTag = Time[0];
                  lastsignal=signal;
                  iAlertCount++;
               }
            }
         }
         else
         {  signal="None";
            iAlertCount=0;
         }
      }
   }
   else if (Alert.On.Cross.Type==2)
   {
      if ((dMA>dChimp) && (dMA2<dChimp2) && (dChimp>Alert.Threshold.Level*(-1))) 
      {  if (Use.Alert.On.Cross)
         {  signal="Short";
            if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
            {  
               Alert ("MA Crossing Over Chimp ==> SHORT ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" MA Crossing Over Chimp ==> SHORT "), "C:\\");
               alertTag = Time[0];
               lastsignal=signal;
               iAlertCount++;
            }
         }
      }
      else 
      {  
         if ((dMA<dChimp) && (dMA2>dChimp2) && (dChimp>Alert.Threshold.Level)) 
         {  
            if (Use.Alert.On.Cross)
            {  
               signal="Long";
               if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
               {  
                  Alert ("Chimp Crossing Over MA ==> LONG ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
                  if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" Chimp Crossing Over MA ==> LONG "), "C:\\");
                  alertTag = Time[0];
                  lastsignal=signal;
                  iAlertCount++;
               }
            }
         }
         else
         {  signal="None";
            iAlertCount=0;
         }
      }
   }
}


void DrawArrows()
{
   for(int i=600; i>=0; i--) 
   {  
      if (Alert.On.Cross.Type==0)
      {
         if ((MapBuffer5[i+1]>MapBuffer4[i+1]) && (MapBuffer5[i+2]<MapBuffer4[i+2])) 
         {  if (Draw.Arrows.On.Chart)
            {  ObjectCreate ("ChimpShort  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],High[i+1]+5*Point);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,164);//242
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,2);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,Red);
            }
         }
         else 
         {  if ((MapBuffer5[i+1]<MapBuffer4[i+1]) && (MapBuffer5[i+2]>MapBuffer4[i+2])) 
            {  if (Draw.Arrows.On.Chart)
               {  ObjectCreate ("ChimpLong  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],Low[i+1]-3*Point);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,164);//241
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,2);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,Aqua);
               }
            }
         }
      }      
      if (Alert.On.Cross.Type==1)
      {
         if ((MapBuffer5[i+1]>MapBuffer4[i+1]) && (MapBuffer5[i+2]<MapBuffer4[i+2]) && (MapBuffer4[i+1]>Alert.Threshold.Level)) 
         {  if (Draw.Arrows.On.Chart)
            {  ObjectCreate ("ChimpShort  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],High[i+1]+5*Point);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,164);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,2);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,Red);
            }
         }
         else 
         {  if ((MapBuffer5[i+1]<MapBuffer4[i+1]) && (MapBuffer5[i+2]>MapBuffer4[i+2]) && (MapBuffer4[i+1]<Alert.Threshold.Level*(-1))) 
            {  if (Draw.Arrows.On.Chart)
               {  ObjectCreate ("ChimpLong  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],Low[i+1]-3*Point);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,164);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,2);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,Aqua);
               }
            }
         }
      }      
      if (Alert.On.Cross.Type==2)
      {
         if ((MapBuffer5[i+1]>MapBuffer4[i+1]) && (MapBuffer5[i+2]<MapBuffer4[i+2]) && (MapBuffer4[i+1]<Alert.Threshold.Level*(-1))) 
         {  if (Draw.Arrows.On.Chart)
            {  ObjectCreate ("ChimpShort  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],High[i+1]+5*Point);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,164);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,2);
               ObjectSet    ("ChimpShort  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,Red);
            }
         }
         else 
         {  if ((MapBuffer5[i+1]<MapBuffer4[i+1]) && (MapBuffer5[i+2]>MapBuffer4[i+2]) && (MapBuffer4[i+1]>Alert.Threshold.Level))  
            {  if (Draw.Arrows.On.Chart)
               {  ObjectCreate ("ChimpLong  "+TimeToStr(Time[i+1]),OBJ_ARROW,0,Time[i+1],Low[i+1]-3*Point);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_ARROWCODE,164);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_WIDTH,2);
                  ObjectSet    ("ChimpLong  "+TimeToStr(Time[i+1]),OBJPROP_COLOR,Aqua);
               }
            }
         }
      }      
   }
} 


void RemoveArrows()
{
   for(int i=600; i>=0; i--) 
   {  
      ObjectDelete("ChimpShort  "+TimeToStr(Time[i+1]));
      ObjectDelete("ChimpLong  "+TimeToStr(Time[i+1]));
   }      

}
//------------------------------------------------------------------------------------+ 


